﻿Option Explicit On

Module Module1

    Public strEHL As String, strEHF As String
    Public strLager As String, strLastart As String
    Public EMod As Single, SchubF As Single
    Public N As Single, L As Single, Iy As Single
    Public q As Single, e0 As Single
    Public F As Single, a As Single
    Public sin1 As Double, sin2 As Double
    Public cos1 As Double, cos2 As Double
    Public tan1 As Double, tan2 As Double
    Public eps As Double, Nenn As Double
    Public AQ1 As Double, AQ As Double
    Public BQ1 As Double, BQ As Double
    Public CQ1 As Double, CQ As Double
    Public Mi1 As Double, Mi As Double
    Public Mk1 As Double, Mk As Double
    Public SMi1 As Double, SMi As Double
    Public SMk1 As Double, SMk As Double
    Public sk As Single, NKi As Single
    Public Wert1 As Single

    Public Const strPgmName = "WGVIIOrdnung"
    Public Const strVersion = "5.0"
    Const pi = 3.14159

    Public Sub Hauptprogramm()
        'Vorwerte

        If N < 0 Then eps = L * Math.Sqrt(Math.Abs(N) * SchubF / EMod / Iy) Else eps = 0
        If eps < 0.05 Then eps = 0
        AQ1 = 2 : BQ1 = 1 : CQ1 = 2 : AQ = 2 : BQ = 1 : CQ = 2
        If eps > 0 Then
            sin1 = Math.Sin(eps) : sin2 = Math.Sin(eps / 2) : cos1 = Math.Cos(eps) : cos2 = Math.Cos(eps / 2)
            tan1 = Math.Tan(eps) : tan2 = Math.Tan(eps / 2)
            Nenn = 2 * SchubF * (1 - cos1) - eps * sin1
            AQ = eps / 2 / Nenn * (SchubF * sin1 - eps * cos1)
            BQ = eps / 2 / Nenn * (eps - SchubF * sin1)
            CQ = (AQ * AQ - BQ * BQ) / 0.75 / AQ
            SMi1 = 0 : SMi = 0 : SMk1 = 0 : SMk = 0
        End If

        If strLastart = "1" Or strLastart = "3" Then
            Call Mik_Gleichlast(eps)
            SMi1 = Mi1
            SMi = Mi
            SMk1 = Mk1
            SMk = Mk
        End If

        If strLastart = "2" Or strLastart = "3" Then
            Call Mik_Einzellast(eps)
            SMi1 = SMi1 + Mi1
            SMi = SMi + Mi
            SMk1 = SMk1 + Mk1
            SMk = SMk + Mk
        End If

        'Knicklast (Obergrenze)
        Select Case strLager
            Case 1 : sk = L / 2
            Case 2 : sk = 0.7 * L
            Case 3 : sk = 2 * L
        End Select
        NKi = pi ^ 2 * EMod * Iy / sk ^ 2

    End Sub

    Public Sub Mik_Gleichlast(ByVal eps As Double)
        'Stabendmomente für Gleichlast q
        'Theorie I. Ordnung
        Select Case strLager
            Case 1 : Mi1 = -q * L * L / 12 : Mk1 = Mi1
            Case 2 : Mi1 = -q * L * L / 8 : Mk1 = 0
            Case 3 : Mi1 = -q * L * L / 2 : Mk1 = 0
        End Select

        If eps = 0 Then
            Mi = Mi1
            Mk = Mk1
            'Theorie II. Ordnung
        Else
            Select Case strLager
                Case 1 : Mi = (eps / 2 / tan2 - 1) / eps / eps : Mk = Mi
                Case 2 : Mi = (0.5 - tan2 / eps) / (SchubF - eps / tan1) : Mk = 0
                Case 3 : Mi = (tan2 / eps - 1) * tan1 / eps : Mk = 0
            End Select
            Mi = Mi * SchubF * (q * L * L + 8 * Math.Abs(N) * e0)
            Mk = Mk * SchubF * (q * L * L + 8 * Math.Abs(N) * e0)
        End If
    End Sub

    Public Sub Mik_Einzellast(ByVal eps As Double)
        'Stabendmomente für Einzellast F
        Dim alfa As Double, beta As Double, ZwWert As Double

        'Theorie I. Ordnung
        alfa = a / L : beta = 1 - alfa
        Select Case strLager
            Case 1 : Mi1 = -F * a * beta * beta : Mk1 = -F * a * alfa * beta
            Case 2 : Mi1 = -F / 2 * alfa * beta * (L + a) : Mk1 = 0
            Case 3 : Mi1 = -F * a : Mk1 = 0
        End Select

        'Theorie II. Ordnung
        If eps = 0 Then
            Mi = Mi1
            Mk = Mk1
            'Theorie II. Ordnung
        Else
            Select Case strLager
                Case 1 : ZwWert = SchubF / eps * (Math.Sin(eps * alfa) + Math.Sin(eps * beta) - sin1)
                    Mi = -(ZwWert + alfa + beta * cos1 - Math.Cos(eps * beta)) / Nenn
                    Mk = -(ZwWert + beta + alfa * cos1 - Math.Cos(eps * alfa)) / Nenn
                Case 2 : Mi = (beta - Math.Sin(eps * beta) / sin1) / (SchubF - eps / tan1)
                    Mk = 0
                Case 3 : Mi = (Math.Sin(eps * beta) - sin1) / eps / cos1
                    Mk = 0
            End Select
            Mi = Mi * SchubF * F * L
            Mk = Mk * SchubF * F * L
        End If
    End Sub

    Public Sub Vorbelegung()
        'Vorbelegung der Eingabefelder
        strEHL = "m" : strEHF = "kN"
        EMod = 210000000.0#
        SchubF = 1
        N = -1000
        L = 1
        Iy = 0.0001
        strLager = "1"
        strLastart = "1"
        q = 10
        e0 = 0
        F = 0
        a = 0
    End Sub

End Module
